' rough HB-25 motor controller object

var
  long hb_stack[20]
  long motor1, motor2
  byte pin, mode, cog, state


pub config(pin1, mode1, state1)  'pin, 0-single 1-dual, 0-manual 1-auto refresh

  if state == 0 and state1 == 1   'clears cog influence when transitioning from manual state to auto state
    dira[pin1]~
    outa[pin1]~
    
  pin  := pin1
  mode := mode1
  state := state1
  
  if state == 0         'get cog ready to pulse and kill any auto cog
    stop
    dira[pin]~~
    outa[pin]~

pub set_motors(pulse1, pulse2)

  pulse1 #>= 1000            'limit pulses to valid values
  pulse1 <#= 2000

  motor1 := ((pulse1 * (clkfreq / 1_000_000)) - 1200) #> 381  'produces pulse widths in clock cycles - overhead

  pulse2 #>= 1000            'limit pulses to valid values    
  pulse2 <#= 2000

  motor2 := ((pulse2 * (clkfreq / 1_000_000)) - 1200 ) #> 381

pub pulse_motors

  outa[pin]~~
  waitcnt(motor1 + cnt)
  outa[pin]~
  if mode
    waitcnt(clkfreq / 500 + cnt) 'wait 2 ms
    outa[pin]~~
    waitcnt(motor2 + cnt)
    outa[pin]~
  waitcnt(clkfreq / 200 + cnt) 'speed zone     

pub start_cog :okay 'start a cog for use with communication timeout feature, only runs in auto state

  if state
    stop
    okay := cog := cognew(refresh_cog, @hb_stack) + 1            
  
pub stop         'stops a cog that was previously launched for auto refresh

  if cog
    cogstop(cog~ - 1)
    
pri refresh_cog

  dira[pin]~~
  outa[pin]~   'may be redundant for a freshly launched cog
  repeat
    pulse_motors
    waitcnt(clkfreq / 50 + cnt)



  
    
             
                        
                        